#include "std.h"

bool no_sound = false;

struct ImgInfo
{
	char *file;
	BITMAP *img;
};


struct SndInfo
{
	char *file;
	SAMPLE *sound;
};

static ImgInfo game_imgs[] = 
{
	{ "main_module" },
	{ "watertank" },
	{ "factory" },
	{ "connector" } ,
	{ "lifesupport" },
	{ "powergen" },
	{ "arobot" },
	{ "crobot"},
	{ "logo"},
	{ "j_base"},
	{ "j_factory"},
	{ "j_lifesupport"},
	{ "j_robot"},
	{ 0 },
};

static SndInfo game_sounds[] =
{
	{ 0 },
};


BITMAP *GetImg (const char *file)
{
	int a;

	for(a=0;game_imgs[a].file;a++)
	{
		if(!strcmp (game_imgs[a].file, file))
			return game_imgs[a].img;
	}

	ASSERT (0);
	return 0;
}

SAMPLE *GetSound (const char *file)
{
	int a;

	if(no_sound)
		return 0;

	for(a=0;game_sounds[a].file;a++)
		if(!strcmp (game_sounds[a].file, file))
			return game_sounds[a].sound;

	ASSERT (0);
	return 0;
}

bool Load_GameData()
{
	int a;
	PALETTE pal;
	char path[120];

	for(a=0;game_imgs[a].file;a++)
	{
		sprintf (path, "data/%s.bmp", game_imgs[a].file);
		game_imgs[a].img = load_bitmap(path, pal);
		if(!game_imgs[a].img)
		{
			alert ("Couldn't load file", path, 0, "Abort", 0, 0,0);
			return false;
		}

		al_trace("Loaded image %s\n", path);
	}

	for(a=0;game_sounds[a].file;a++)
	{
		sprintf (path, "data/%s.wav", game_sounds[a].file);
		game_sounds[a].sound = load_wav (path);
		if(!game_sounds[a].sound)
		{
			alert ("Couldn't load sound", path, 0, "Abort", 0,0,0);
			return false;
		}

		al_trace ("Loaded sound %s\n", path);
	}

	return true;
}

void Free_GameData ()
{
	int a;

	for(a=0;game_imgs[a].file;a++)
	{
		destroy_bitmap (game_imgs[a].img);
		game_imgs[a].img = 0;
	}

	for(a=0;game_sounds[a].sound;a++)
	{
		destroy_sample (game_sounds[a].sound);
		game_sounds[a].sound = 0;
	}
}

