template<class T> class TList : public T
{
public:
	TList () : T() { next=0; }

	void RemoveList () 
	{
		TList <T> *c = this, *p;
		while(c) { p=c; c=c->next; delete p; }
	}
	void Link(TList <T> *&list) {
		next = list; list = this;
	}

	int Count() { 
		int i=0;
		for(TList *c=this;c;c=c->next,i++); 
		return i; 
	}
	TList<T> *GetItem (uint i)
	{
		TList<T> *c = this;
		while(i-->0 && c)
			c = c->next;
		return c;
	}
	int ItemIndex (T *item)
	{
		int i = 0;
		TList<T> *c = this;
		while(c) {
			if(c == item) 
				return i;
			i++;
			c = c->next;
		}
		return -1;
	}
	void AppendList (TList<T> *l)
	{
		TList<T> *p, *c = this;
		while(c) {
			p=c;
			c=c->next;
		}
		p->next = l;
	}

	TList<T> *LastItem()
	{
		TList<T> *p, *c = this;
		while(c) {
			p=c;
			c=c->next;
		}
		return p;
	}
	void Unlink(TList <T> *&list)
	{
		if(list == this)
			list = list->next;
		else {
			TList<T> *p, *c = list;
			while(c) {
				if(c == this) {
					p->next = next;
					break;
				}
				p=c; c=c->next;
			}
		}
		next=0;
	}

	TList<T> *next;
};

template <class C> void DeleteList(TList<C> *&l)
{ if(l) l->RemoveList(); l = 0; }

#define ListCount(l) ((l)?(l->Count()):(0))


